'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
function getParents() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      index = _ref.index,
      _ref$parentField = _ref.parentField,
      parentField = _ref$parentField === undefined ? 'parent' : _ref$parentField;

  return function (rows) {
    var parents = [];
    var currentIndex = index;
    var cell = rows[index];
    var previousParent = void 0;

    if (!cell || typeof cell[parentField] === 'undefined' || cell[parentField] === null) {
      return parents;
    }

    while (cell) {
      if (cell[parentField] === null) {
        if (previousParent !== cell[parentField]) {
          parents.unshift(cell);
        }

        break;
      }
      if (typeof cell[parentField] !== 'undefined') {
        if (typeof previousParent !== 'undefined' && previousParent !== cell[parentField]) {
          parents.unshift(cell);
        }
      } else {
        if (typeof previousParent !== 'undefined') {
          parents.unshift(cell);
        }

        break;
      }

      currentIndex -= 1;

      previousParent = cell[parentField];
      cell = rows[currentIndex];
    }

    return parents;
  };
}

exports.default = getParents;